/* Copyright (C) 2000 Decision Computer International, Inc.,
   This file is part of the Decision PCCOM development tool

   The sample.c is a simple sample source code using the 
   development tool. It demonstrate how to  intialize, transmit 
   and receive using Decision PCCOM Serial cards. 

   The sample.c is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
   See the GNU Library General Public License for more details. 
 
   -Armz27
*/
#include <stdio.h>
#include "libpccomprof.h"

int initReturn, openReturn, closeReturn;
size_t txReturn, rxReturn; /* unsigned int txReturn; */
int intFlushOut, intFlushIn;
char strReceive[1000];
int intModemStatus, intCTS, intDSR, intRI, intCD, intDTR, intRTS;

void StartOperation()
{
 openReturn = commopen("/dev/ttyS0");
 printf("commopen return %i\n\n", openReturn);
 sleep(1);

 initReturn = comminit("/dev/ttyS0", 9600, 8, "no", 1, "hardware");
 printf("comminit return %i\n\n", initReturn);
 sleep(1);
}

void FlushSample()
{
 printf("Cleaning the transmit buffer....");
 intFlushOut = commflushtx("/dev/ttyS0");
 printf("... done<return: %i>\n\n",intFlushOut);
 sleep(1);
 printf("Cleaning the receive buffer....");
 intFlushIn = commflushrx("/dev/ttyS0");
 printf("... done<return: %i>\n\n",intFlushIn);
 sleep(1);
}

void TransmitReceiveSample()
{
int intRXCounter;
 txReturn = commtxblk("/dev/ttyS0", "testing", 7);
 printf("Transmitting testing\n");
 printf("Feedback of transmit is %d\n\n", txReturn);
 sleep(1);

 intRXCounter = commgetRxCount("/dev/ttyS0");
 printf("About to read %i of data\n",intRXCounter);
 rxReturn = commrxblk("/dev/ttyS0", strReceive, 7);
 strReceive[rxReturn]=0; /* set end of string, so we can printf */
 printf("Received: <%s> string of data\n", strReceive); 
 printf("Feedback of receive is %d\n\n", rxReturn);
 sleep(1);
}

void GetModemStatusSample()
{
 printf("Getting the modem status:.... return<");
 intModemStatus = commgetstat("/dev/ttyS0");
 printf("%i>\n", intModemStatus);
 intCTS = 0x0001;
 if ((intCTS & intModemStatus) == 0x0001) 
    printf("CTS = On; "); 
 else 
    printf("CTS = Off; ");
 intDSR = 0x0010;
 if ((intDSR & intModemStatus) == 0x0010)
    printf("DSR = On; ");
 else
    printf("DSR = Off; ");
 intRI = 0x0100;
 if ((intRI & intModemStatus) == 0x0100)
    printf("RI = On; ");
 else
    printf("RI = Off; ");
 intCD = 0x1000;
 if ((intCD & intModemStatus) == 0x1000)
    printf("CD = On\n\n");
 else
    printf("CD = Off\n\n");
 sleep(1);
}

void SampleDTR(int myFlag)
{
 printf("Setting <Data Terminal Ready> to %i...",myFlag);
 intDTR = commsetDTR("/dev/ttyS0",myFlag);
 printf("return[%i]\n\n",intDTR);
 sleep(1);
}

void SampleRTS(int myFlag)
{
 printf("Setting <Request To Send> to %i...",myFlag);
 intRTS = commsetRTS("/dev/ttyS0",myFlag);
 printf("return[%i]\n\n",intRTS);
 sleep(1);
}

void StopOperation()
{
 closeReturn = commclose("/dev/ttyS0");
 printf("commclose return %i\n\n", closeReturn);
}

int main()
{

 printf("\n\n\n\n");
 StartOperation();

 FlushSample();

 TransmitReceiveSample();

 GetModemStatusSample();
 SampleDTR(0);
 GetModemStatusSample();
 SampleDTR(1);
 GetModemStatusSample();
 SampleRTS(0);
 GetModemStatusSample();
 SampleRTS(1);
 GetModemStatusSample();
 
 StopOperation();
 exit(0);
}
